Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.udo.cs.miningmart.m4
Interface OpParam

All Superinterfaces:
  M4Data, M4Object

All Known Implementing Classes:
  OpParam

public interface OpParam
extends M4Data

Version:
  $Id: OpParam.java,v 1.3 2006/04/11 14:10:12 euler Exp $
Author:
  Timm Euler, Daniel Hakenjos

Method Summary
`Value` | `createValueObject()` Convenience method to create a Value object of the right datatype for this parameter.
`java.util.Collection` | `getApplicableConstraints()` Returns all Constraint objects that constrain this operator parameter.
`java.lang.String` | `getConceptualDatatypeForValue()` Returns a conceptual data type that can be used for a Value Parameter Object of this OpParam, or null if this OpParam does not represent a Value Parameter.
`java.lang.String` | `getInput()` Similar to `isInput()`: Gets the input/output property, but returns a `String`.
`int` | `getMaxArg()` Gets the maxArg.
`java.lang.Integer` | `getMaximumNumberOfArrayFields()` This method makes sense only if `isArray()` returns TRUE.
`int` | `getMinArg()` Gets the minArg.
`java.util.Collection` | `getOneOfList()` This method makes sense only if `isOneOf()` returns TRUE.
`Operator` | `getTheOperator()` Gets the Operator.
`short` | `getType()` Gets the type.
`java.lang.String` | `getTypeS()`
`boolean` | `isArray()`
`boolean` | `isBaseAttribParameter()` Convenience method to `getType()` and `getTypeS()`.
`boolean` | `isConceptParameter()` Convenience method to `getType()` and `getTypeS()`.
`boolean` | `isCoordinated()`
`boolean` | `isFeatureParameter()` Convenience method to `getType()` and `getTypeS()`.
`boolean` | `isInput()` Gets the input/output property.
`boolean` | `isLoopable()`
`boolean` | `isMcfParameter()` Convenience method to `getType()` and `getTypeS()`.
`boolean` | `isOneOf()`
`boolean` | `isOptional()`
`boolean` | `isRelationParameter()` Convenience method to `getType()` and `getTypeS()`.
`boolean` | `isValueParameter()` Convenience method to `getType()` and `getTypeS()`.
`void` | `setInput(java.lang.String ioType)` Sets the input/output property.
`void` | `setMaxArg(int maxArg)` Sets the maxArg.
`void` | `setMinArg(int minArg)` Sets the minArg.
`void` | `setTheOperator(Operator operator)` Sets the Operator.
`void` | `setType(java.lang.String typeString)` Sets the type.

Methods inherited from interface edu.udo.cs.miningmart.m4.M4Data
`deleteSoon, getDocumentation, getValidName, isDirty, isWaitingForDelete, setDocumentation`

Methods inherited from interface edu.udo.cs.miningmart.m4.M4Object
`doPrint, doPrint, equals, executeBusinessSingleValueSqlRead, executeBusinessSingleValueSqlReadL, executeBusinessSqlRead, executeBusinessSqlWrite, executeM4SingleValueSqlRead, executeM4SingleValueSqlReadL, executeM4SqlRead, executeM4SqlWrite, getCasePrintObject, getId, getM4Db, getM4ObjectFromCache, getName, getNextM4SequenceValue, isNew, load, print, putM4ObjectToCache, replaceSpacesInName, setId, setName`

Method Detail

### isInput

    public boolean isInput()

  Gets the input/output property.

  Returns:
    Returns true iff the parameter is an input.

### getInput

    public java.lang.String getInput()

  Similar to `isInput()`: Gets the input/output property, but returns a `String`.

  Returns:
    Returns a `String` indicating if the parameter is an input or output.

### getMaxArg

    public int getMaxArg()

  Gets the maxArg.

  Returns:
    Returns an int. A return value of "-1" represents a NULL in the database, a return value of "0" is not possible.

### getMinArg

    public int getMinArg()

  Gets the minArg.

  Returns:
    Returns a int

### getType

    public short getType()

  Gets the type.

  Returns:
    Returns a short

### getTypeS

    public java.lang.String getTypeS()
                              throws ParameterError

  Returns:
    the type in its database `String` representation.
  Throws:
    `ParameterError`
  See Also:
    `getType()`

### setInput

    public void setInput(java.lang.String ioType)
                  throws M4Exception

  Sets the input/output property.

  Parameters:
    `ioType` - Either "IN" for input parameters, or "OUT".
  Throws:
    `M4Exception`

### setMaxArg

    public void setMaxArg(int maxArg)

  Sets the maxArg.

  Parameters:
    `maxArg` - The maxArg to set

### setMinArg

    public void setMinArg(int minArg)

  Sets the minArg.

  Parameters:
    `minArg` - The minArg to set

### setType

    public void setType(java.lang.String typeString)
                 throws M4Exception

  Sets the type.

  Throws:
    `M4Exception`

### getTheOperator

    public Operator getTheOperator()

  Gets the Operator.

  Returns:
    Returns an Operator

### setTheOperator

    public void setTheOperator(Operator operator)
                        throws M4Exception

  Sets the Operator.

  Parameters:
    `operator` - The Operator to set
  Throws:
    `M4Exception`

### getApplicableConstraints

    public java.util.Collection getApplicableConstraints()
                                                  throws M4Exception

  Returns all Constraint objects that constrain this operator parameter.

  Returns:
    a Collection of Constraint objects
  Throws:
    `M4Exception`

### isLoopable

    public boolean isLoopable()
                       throws M4Exception

  Returns:
    TRUE iff this parameter can take different values for each loop. This can only occur if the operator is loopable.
  Throws:
    `M4Exception`

### isCoordinated

    public boolean isCoordinated()
                          throws M4Exception

  Returns:
    TRUE iff this parameter is an array whose values must be coordinated positionwise with the values of another parameter array. Compare the method `getCoordinatedParameterArrays()` in the class `Operator`.
  Throws:
    `M4Exception`

### isOneOf

    public boolean isOneOf()
                    throws M4Exception

  Returns:
    TRUE iff this parameter can only take the values specified in a list. The list is given by calling `getOneOfList()`.
  Throws:
    `M4Exception`

### isOptional

    public boolean isOptional()
                       throws M4Exception

  Returns:
    TRUE iff this parameter is optional.
  Throws:
    `M4Exception`

### isArray

    public boolean isArray()
                    throws M4Exception

  Returns:
    TRUE iff this parameter takes the form of an array. FALSE iff it is a single parameter.
  Throws:
    `M4Exception`

### isConceptParameter

    public boolean isConceptParameter()
                               throws M4Exception

  Convenience method to `getType()` and `getTypeS()`.

  Returns:
    TRUE iff this parameter is of type Concept.
  Throws:
    `M4Exception`

### isValueParameter

    public boolean isValueParameter()
                             throws M4Exception

  Convenience method to `getType()` and `getTypeS()`.

  Returns:
    TRUE iff this parameter is of type Value.
  Throws:
    `M4Exception`

### getConceptualDatatypeForValue

    public java.lang.String getConceptualDatatypeForValue()
                                                   throws M4Exception

  Returns a conceptual data type that can be used for a Value Parameter Object of this OpParam, or null if this OpParam does not represent a Value Parameter.

  Returns:
    a conceptual data type String
  Throws:
    `M4Exception`

### createValueObject

    public Value createValueObject()
                            throws M4Exception

  Convenience method to create a Value object of the right datatype for this parameter. This method throws an exception if `isValueParameter()` returns FALSE.

  Returns:
    a Value object with matching conceptual datatype
  Throws:
    `M4Exception` - is thrown if this is no Value parameter

### isRelationParameter

    public boolean isRelationParameter()
                                throws M4Exception

  Convenience method to `getType()` and `getTypeS()`.

  Returns:
    TRUE iff this parameter is of type Relation.
  Throws:
    `M4Exception`

### isFeatureParameter

    public boolean isFeatureParameter()
                               throws M4Exception

  Convenience method to `getType()` and `getTypeS()`.

  Returns:
    TRUE iff this parameter is of type Feature.
  Throws:
    `M4Exception`

### isBaseAttribParameter

    public boolean isBaseAttribParameter()
                                  throws M4Exception

  Convenience method to `getType()` and `getTypeS()`.

  Returns:
    TRUE iff this parameter is of type BaseAttribute.
  Throws:
    `M4Exception`

### isMcfParameter

    public boolean isMcfParameter()
                           throws M4Exception

  Convenience method to `getType()` and `getTypeS()`.

  Returns:
    TRUE iff this parameter is of type MultiColumnFeature.
  Throws:
    `M4Exception`

### getOneOfList

    public java.util.Collection getOneOfList()
                                      throws M4Exception

  This method makes sense only if `isOneOf()` returns TRUE. In that case this method returns the list of possible values that this parameter can take. A collection of Strings is returned. Otherwise an empty collection is returned.

  Returns:
    a collection of Strings
  Throws:
    `M4Exception`

### getMaximumNumberOfArrayFields

    public java.lang.Integer getMaximumNumberOfArrayFields()
                                                    throws M4Exception

  This method makes sense only if `isArray()` returns TRUE. In that case this method returns the maximum number of positions of the array, if such a maximum exists; otherwise this method returns NULL. The minimum number of array positions can be taken to be 1 if this parameter is not optional (see method `isArray()`).

  Returns:
    The maximum number of array positions or NULL if the number is unconstrained.
  Throws:
    `M4Exception`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005